\documentclass{report}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{amsmath}
\usepackage{amssymb,amsfonts,textcomp}
\usepackage{array}
\usepackage{hhline}
\usepackage{hyperref}
\hypersetup{colorlinks=true, linkcolor=blue, citecolor=blue, filecolor=blue, urlcolor=blue, pdftitle=, pdfauthor=Gilles Vuidel, pdfsubject=, pdfkeywords=}
\usepackage{graphicx}
\usepackage[top=2.501cm,bottom=2.501cm,left=2.501cm,right=2.501cm,nohead]{geometry}
\usepackage{float}
\usepackage{parskip}
\usepackage{multirow}
\usepackage{caption}
\usepackage{fancyvrb}
\makeatletter
\newcommand\arraybslash{\let\\\@arraycr}
\makeatother
% centering figures
\makeatletter
\g@addto@macro\@floatboxreset\centering
\makeatother
\setlength\tabcolsep{1mm}
\renewcommand\arraystretch{1.3}

% saut de page après une section
%\let\oldsection\section
%\renewcommand\section{\clearpage\oldsection}

% saut après itemize
\let\EndItemize\enditemize
\def\enditemize{\EndItemize\medskip}

\begin{document}
 \begin{titlepage}
	
	\centering
	\includegraphics{img/logo.png}\\
	
	\bigskip
	\bigskip
	\bigskip	
	{\Huge
		\bfseries
		LucSim 1.6\\
		\bigskip
		User manual\\
	}
	\bigskip
	\bigskip
	\bigskip
	\bigskip
	\bigskip
	
	{\Large		
		Gilles Vuidel and Jean-Philippe Antoni\\
		\bigskip
		2017-10-24\\
	}
	
\end{titlepage}

\setcounter{tocdepth}{2}
%\renewcommand\contentsname{}
\tableofcontents

\pagebreak

\chapter{Introduction}

\section{About LucSim}

LucSim software is dedicated to ...


\subsection{Authors}
LucSim has been developed at \href{http://thema.univ-fcomte.fr}{ThéMA} laboratory (\href{http://www.ubfc.fr}{Université de Bourgogne Franche-Comté} – \href{http://www.cnrs.fr}{CNRS}) by Jean-Philippe Antoni and Gilles Vuidel in collaboration with : Valentin Garet, Alexis Picard and Rémi Ducceschi.

\subsection{Terms of use}
LucSim is distributed in open source, under the \href{https://www.gnu.org/licenses/gpl-3.0.html}{GPL} license.\\
Source code can be downloaded from the sourcesup git repository : \url{git://git.renater.fr/lucsim.git}.\\
Users must cite the following reference in their publications :\\
??


\section{System requirements}

LucSim runs on any computer supporting Java 8 or later (PC under Linux, Windows, Mac, ...). 
However, when dealing with large datasets, the amount of memory (RAM) will limit the maximum area that can be processed. In addition, processing power (CPU) will determine the speed of computing. For details, see section \nameref{perf}.


\section{Installation and launching LucSim}

LucSim is available for downloading at : \url{http://sourcesup.renater.fr/lucsim}.

\begin{itemize}
	\item Download and install Java 8 or later (\href{http://www.java.com}{java.com}). It is best to install 64 bits version of Java.
	\item Download lucsim-1.6.jar
	\item Launch lucsim-1.6.jar
\end{itemize}

LucSim can be used through 2 user interface : the graphical user interface (GUI) and the command line interface (CLI).

The graphical user interface allows to create project, visualize the data, edit states and rules, and launch simulations. The command line interface allows to run the same calculations on remote computers as well as on computer clusters.

The following chapter (\ref{gui}) describes all of the software features available from the GUI. Chapter \ref{cli} details how to use LucSim on the command line. The transition rule syntax is detailed in Chapter \ref{rule}. And Chapter \ref{perf} reviews the parallelization modes, performance and memory management.


\chapter{Graphical user interface (GUI)}
\label{gui}

Once LucSim is launched, the first step is to create a project based on a raster layer.

\section{Project creation}

To create a new project, use the menu Project / New project. User must a raster layer in Tiff or AsciiGrid format.

\begin{figure}[H]
%	\includegraphics[scale=0.5]{img/new_project-en.png} 
	\caption{Creating a project}
\end{figure}


For opening a project, simply select the corresponding \verb|.ca| file from the Project / Load Project menu.


\section{Data management}

For importing raster data, LucSim supports 2 file formats : Tiff and AsciiGrid.
For Tiff format, the coordinate system can be given by 2 ways : directly in the Tiff file with the GeoTiff extension, or an additional text file with the same name and extension .tfw.


\subsection{Additional layers}

\section{States}

\section{Transition rule}

\section{Simulation}



\chapter{Command line interface (CLI)}
\label{cli}
Once a project has been created from the GUI, it is possible to use LucSim on the command line. This mode is useful for running the software on a remote computer without a graphical interface, automatically launching several processes, or submitting executions on a cluster.

\section{Starting}

\subsection{Launch LucSim in CLI mode}
First you have to open a terminal window. Then, go to the directory of the Graphab program with \textit{cd} command. Finally, type the following command to display the LucSim help screen :
\begin{Verbatim}
java -jar lucsim.jar --help
\end{Verbatim}
Result
\begin{Verbatim}
Usage :
java -jar lucsim.jar [-proc] ...
...
...
\end{Verbatim}
You’re ready to use LucSim in CLI mode.

\subsection{Syntax}
\subsubsection{Definition}
Commands always start with a double dash: \verb|--project, --extract, ...|\\
Global options start with only one dash: \verb|-proc, ...|\\
Parameters does not have dash: \verb|weight, target, ...|

\subsubsection{Character separator}
Blank spaces are used to separate commands and parameters.  You cannot have a name containing blank spaces.

\subsubsection{Help screen syntax}
In the help screen, elements enclosed in brackets are optional. Therefore, elements not in brackets are mandatory. The character \verb+|+ separates the possible options.

\section{Commands}

\subsection{--help : show help screen}
Command:
\begin{Verbatim}
java -jar lucsim-1.0.jar --help
\end{Verbatim}
Result:
\begin{Verbatim}
Usage :
java -jar lucsim.jar [-proc n]
--project project_file.xml COMMAND

Command list :
--extract layer1=layer_name layer2=layer_name function=nbCellSq|nbCellCirc radius=min:inc:max ...
--rulegen [data=file.csv] training=percent [seed=num] [output=dir] algo=J48|Hoeffding [algo ...
\end{Verbatim}


\subsection{--project : load project}
This command sets the path to the project xml file.
\begin{Verbatim}[commandchars=\\\{\}]
java -jar lucsim-1.0.jar --project \textit{path2myproject/myproject.xml}
\end{Verbatim}
This command loads the project \textit{myproject} contained in the \textit{path2myproject} folder.

The \verb|--project| command can be used only once and must be the first command.  All of the following commands below require a loaded project


\section{Options}

\subsection{Parallelization : -proc}
\begin{Verbatim}[commandchars=\\\{\}]
-proc \textit{n}
\end{Verbatim}

LucSim supports one modes of parallelization on the command line: per thread for a computer containing several cores (\verb|-proc|).

For more details, see \nameref{parallelism} section.

If this option is not specified, thread parallelization will be used with the number of cores defined in the graphical interface.



\section{Examples}

In this section, some examples of complete command lines are shown.



\chapter{Rule syntax}
\label{rule}

\chapter{Performance tuning}
\label{perf}

\section{Parallelism to speed up execution}
\label{parallelism}
To reduce visibility calculation execution time, LucSim implements 3 parallelization methods: thread based for a single computer, CUDA to use Graphic Processor Unit (GPU) acceleration, and MPI for computer clusters.



\subsection{One computer : threads}
\label{thread}
Multi-threaded parallelization accelerates computation time on a single machine containing multiple cores or processors. If your computer has more than one core (most of them), you can take advantage of multi-threading to speed up your calculations with LucSim. The execution time is approximately inversely proportional to the number of cores used. 

This parallelism method can be used in GUI and CLI.

\subsubsection{Graphical user interface}
The "Preferences" window accessible from the File menu allows you to set the number of cores used by LucSim. It is set by default to the number of cores of the computer minus 1. After changing the number of cores used by LucSim, it is better to restart LucSim to be sure that the change is taken into account.

\subsubsection{Command line interface}
On the command line, you have to define the number of cores (or processors) that LucSim can use with the \verb|-proc| option :
\begin{Verbatim}
java -jar lucsim-1.0.jar -proc 8 --project path2myproject/myproject.xml ...
\end{Verbatim}
By default, CLI uses the number of processors defined in the preferences window of the GUI.

By increasing the number of cores used by LucSim, you increase the memory size used by LucSim at the same time.



\section{Memory management}
\label{memory}
By default, the amount of memory available for LucSim is system dependent.  It can vary from 128 Mb to several Gb.  In most cases, LucSim will run normally.  But if you have a large project, some processes would be slow or even crash due to memory limitation.

Also, if you use thread-based parallelism (\nameref{thread}), LucSim will need more memory for each core used.

In all cases, if LucSim execution terminates with OutOfMemoryError
or GC overhead, you need to increase memory allocated to LucSim.


\subsection{Graphical user interface}
The memory allocated for LucSim can be changed in the "Preferences" window on the File / Preferences menu. After changing this setting, LucSim must be restarted to take the new memory size into account.

In GUI, LucSim needs more memory than command line because of the layers display. If you are too limited in RAM, you can run the calculations on command line interface to reduce LucSim memory requirements (see \nameref {cli}).

\subsection{Command line interface}
To define manually the maximum amount of memory allocated to LucSim, use Java option \verb|-Xmx|:

\begin{Verbatim}
java -Xmx4g -jar lucsim-1.0.jar ... # 4Gb allocated
java -Xmx1500m -jar lucsim-1.0.jar ... # 1500 Mb -> 1.5Gb allocated
\end{Verbatim}

If you cannot allocate more than 1Gb or 1.5Gb and your computer has more memory available, you have
probably a 32-bit version of Java, which is limited to less than 2Gb of memory.  Check your Java version:
\begin{Verbatim}
java -version
\end{Verbatim}
If it is a 32-bit version, install a 64-bit Java version to handle all your computer memory.


%\section{Multi-résolution}

\end{document}
